;*******************************************************************************
;* Digitlis technika 9. laboratrium                                          *
;* Legnagyobb kzs oszt szmtsa szoftveresen.                              *
;*******************************************************************************
DEF SW   0x81                ; DIP kapcsol adatregiszter           (csak olvashat)
DEF BT   0x84                ; Nyomgomb adatregiszter              (csak olvashat)
DEF DIG0 0x90                ; Kijelz DIG0 adatregiszter           (rhat/olvashat)
DEF DIG1 0x91                ; Kijelz DIG1 adatregiszter           (rhat/olvashat)
DEF DIG2 0x92                ; Kijelz DIG2 adatregiszter           (rhat/olvashat)
DEF DIG3 0x93                ; Kijelz DIG3 adatregiszter           (rhat/olvashat)


;*******************************************************************************
;* A program kezdete. A programmemria 0x00 s a 0x01 cme a reset, illetve    *
;* a megszakts vektor. Ide ugr utastsokat kell elhelyezni, amelyek a      *
;* megfelel programrszre ugranak. Ha nem hasznlunk megszaktst, akkor a    *
;* program kezddhet a 0x00 cmen is.                                          *
;*******************************************************************************
start:
    mov     r0, BT              ;A nyomgombok llapotnak beolvassa.
    tst     r0, #0x01           ;BT0 vizsglata (indts).
    jz      start               ;Ugrs, ha BT0 nincs megnyomva.
    
    mov     r1, #0              ;Az A operandus trlse (r1).
    mov     r2, #0              ;A B operandus trlse (r2).
    
read_a:
    mov     r1, SW              ;Az A operandus beolvassa...
    mov     r8, r1              ;s megjelentse a kijelz els 2 digitjn.
    mov     r9, #DIG0
    jsr     disp_wr
    mov     r0, BT              ;A nyomgombok llapotnak beolvassa.
    tst     r0, #0x02           ;BT1 vizsglata (A op. betltse).
    jz      read_a              ;Ugrs, ha BT1 nincs megnyomva.
    
read_b:
    mov     r2, SW              ;A B operandus beolvassa...
    mov     r8, r2              ;s megjelentse a kijelz utols 2 digitjn.
    mov     r9, #DIG2
    jsr     disp_wr
    mov     r0, BT              ;A nyomgombok llapotnak beolvassa.
    tst     r0, #0x04           ;BT2 vizsglata (B op. betltse).
    jz      read_b              ;Ugrs, ha BT2 nincs megnyomva.
    
gcd_loop:                       ;Az LNKO szmts kezdete.
    mov     r8, r1              ;Az A operandus regiszter megjelentse.
    mov     r9, #DIG0
    jsr     disp_wr
    mov     r8, r2              ;A B operandus regiszter megjelentse.
    mov     r9, #DIG2
    jsr     disp_wr
    
    cmp     r1, r2              ;A s B kztti relci vizsglata:
    jc      b_gt_a              ;-ha A-B < 0, azaz A < B, akkor C=1
    jz      start               ;-ha A-B = 0, azaz A = B, akkor Z=1
    
a_gt_b:                         ;A > B eset.
    ;Binris kivons.
    sub     r1, r2              ;A = A-B kivons elvgzse.
    
    ;BCD kivons.
    ;mov     r8, r1
    ;mov     r9, r2
    ;jsr     bcd_sub
    ;mov     r1, r8
    jmp     gcd_loop            ;Ugrs a ciklus elejre.
    
b_gt_a:                         ;A < B eset.
    ;Binris kivons.
    sub     r2, r1              ;B = B-A kivons elvgzse.
    
    ;BCD kivons.
    ;mov     r8, r2
    ;mov     r9, r1
    ;jsr     bcd_sub
    ;mov     r2, r8
    jmp     gcd_loop            ;Ugrs a cuklus elejre.
    

;*******************************************************************************
;* Kt digites megjelents a htszegmenses kijelzn.                          *
;* Paramterek:                                                                *
;*   r8: A megjelentend szm.                                                *
;*   r9: Az egyesek helyirtkhez tartoz digit regiszter cme.               *
;*******************************************************************************
disp_wr:
    mov     r10, r8             ;Msolat ksztse a szmrl.
    and     r10, #0x0f          ;Trljk a fels 4 bitet.
    add     r10, #bin_7seg      ;A htszegmenses dekder tblzat elem cme.
    mov     r10, (r10)          ;A tblzat elem beolvassa...
    mov     (r9), r10           ;...s megjelentse a kijelzn.
    
    add     r9, #1              ;A mutatt a kvetkez digitre lltjuk.
    
    mov     r10, r8             ;Msolat ksztse a szmrl.
    swp     r10                 ;A megjelentend rtk az als 4 bitbe kerl.
    and     r10, #0x0f          ;Trljk a fels 4 bitet.
    add     r10, #bin_7seg      ;A htszegmenses dekder tblzat elem cme.
    mov     r10, (r10)          ;A tblzat elem beolvassa...
    mov     (r9), r10           ;...s megjelentse a kijelzn.
    
    rts                         ;Visszatrs a hvhoz.


;*******************************************************************************
;* Kt digites BCD kivons.                                                    *
;* Paramterek:                                                                *
;*   r8: Kisebbtend.                                                         *
;*   r9: Kivonand.                                                            *
;* Visszatrsi rtk:                                                         *
;*   r8: Klnbsg.                                                            *
;*******************************************************************************
;bcd_sub:
    ;mov     r10, r8             ;Msolat ksztse a kisebbtendrl.
    ;mov     r11, r9             ;Msolat ksztse a kivonandrl.
    ;and     r10, #0x0f          ;A fels 4 bit trlse a msolatokban.
    ;and     r11, #0x0f
    ;sub     r10, r11            ;A kivons elvgzse az egyesek helyirtkn.
    ;mov     r11, r10            ;Msolat ksztse a klnbsgrl.
    ;tst     r10, #0x10          ;A 4 bites klnbsg negatv (volt tvitel)?
    ;jz      no_corr1            ;Ugrs, ha nem.
    ;add     r10, #0x0a          ;Negatv klnbsg esetn BCD korrekci (+10).
;no_corr1:
    ;and     r10, #0x0f          ;A klnbsg als 4 bitje kell csak.
    ;and     r11, #0x10          ;A msolatbl az tvitel kell csak.
    
    ;and     r8, #0xf0           ;Az als 4 bit trlse az eredeti adatokban.
    ;and     r9, #0xf0
    ;add     r9, r11             ;A kivonandhoz hozzadjuk az tvitelt.
    ;sub     r8, r9              ;A kivons elvgzse a tizesek helyirtkn.
    ;jnc     no_corr10           ;Ugrs, ha a klnbsg nemnegatv.
    ;add     r8, #0xa0           ;Negatv klnbsg esetn BCD korrekci (+10).
;no_corr10:

    ;or      r8, r10             ;A teljes 2 digites klnbsg.
    ;rts                         ;Visszatrs a hvhoz.


;*******************************************************************************
;* Az adatmemria inicializlsa a htszegmenses dekder tblzattal.          *
;*******************************************************************************
    DATA
    
bin_7seg:
    DB      0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07
    DB      0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71
    